/*******************************************************************************
 * Copyright (c) 2010 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Nicolas Bros (Mia-Software)
 *******************************************************************************/
package org.eclipse.gmt.modisco.infra.browser.preferences;

/**
 * Constant definitions for Browser plug-in preferences
 */
public final class PreferenceConstants {

	private PreferenceConstants() {
		// constants class: no need to instantiate
	}

	/**
	 * The depth to load resources in the MoDisco model browser (-1 for maximum
	 * depth)
	 */
	public static final String P_BROWSER_LOADING_DEPTH = "browser_loading_depth"; //$NON-NLS-1$
	/**
	 * Whether to ask the depth to load resources in the MoDisco model browser
	 * each time a model is opened
	 */
	public static final String P_BROWSER_ASK_LOADING_DEPTH = "browser_ask_loading_depth"; //$NON-NLS-1$
}
