/**
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Gregoire Dupe (Mia-Software) - initial API and implementation
 */
package org.eclipse.gmt.modisco.java.discoverer.benchmark.cdo.server;

import java.util.Map;

import org.eclipse.emf.cdo.server.IRepository;
import org.eclipse.emf.cdo.server.db.CDODBUtil;
import org.eclipse.emf.cdo.server.db.mapping.IMappingStrategy;
import org.eclipse.gmt.modisco.infra.common.cdo.derby.DerbyCDOServer;

public class DerbyCDOServerNoAudits extends DerbyCDOServer {

	@Override
	protected Map<String, String> getProps() {
		Map<String, String> props = super.getProps();
		props
				.put(IRepository.Props.SUPPORTING_AUDITS, Boolean.FALSE
						.toString());
		return props;
	}

	@Override
	protected IMappingStrategy getMappingStrategy() {
		IMappingStrategy mappingStrategy = CDODBUtil
				.createHorizontalMappingStrategy(false);
		return mappingStrategy;
	}

	@Override
	public String getDescription() {
		return "Derby, NOT_SUPPORTING_AUDITS"; //$NON-NLS-1$
	}
}
