/**
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Grgoire Dup (Mia-Software) - initial API and implementation
 * 
 *
 * $Id$
 */
package org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel;

import java.util.Date;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Configuration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getDicoveryDate <em>Dicovery Date</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getAlgoVariante <em>Algo Variante</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getDiscovererClassName <em>Discoverer Class Name</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getSaveTime <em>Save Time</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getTotalExecutionTime <em>Total Execution Time</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getMetaModelVariante <em>Meta Model Variante</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getMaxUsedMemory <em>Max Used Memory</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration()
 * @model
 * @generated
 */
public interface Configuration extends EObject {
	/**
	 * Returns the value of the '<em><b>Dicovery Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dicovery Date</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dicovery Date</em>' attribute.
	 * @see #setDicoveryDate(Date)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_DicoveryDate()
	 * @model
	 * @generated
	 */
	Date getDicoveryDate();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getDicoveryDate <em>Dicovery Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dicovery Date</em>' attribute.
	 * @see #getDicoveryDate()
	 * @generated
	 */
	void setDicoveryDate(Date value);

	/**
	 * Returns the value of the '<em><b>Algo Variante</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Algo Variante</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Algo Variante</em>' attribute.
	 * @see #setAlgoVariante(String)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_AlgoVariante()
	 * @model
	 * @generated
	 */
	String getAlgoVariante();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getAlgoVariante <em>Algo Variante</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Algo Variante</em>' attribute.
	 * @see #getAlgoVariante()
	 * @generated
	 */
	void setAlgoVariante(String value);

	/**
	 * Returns the value of the '<em><b>Discoverer Class Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Discoverer Class Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Discoverer Class Name</em>' attribute.
	 * @see #setDiscovererClassName(String)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_DiscovererClassName()
	 * @model
	 * @generated
	 */
	String getDiscovererClassName();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getDiscovererClassName <em>Discoverer Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Discoverer Class Name</em>' attribute.
	 * @see #getDiscovererClassName()
	 * @generated
	 */
	void setDiscovererClassName(String value);

	/**
	 * Returns the value of the '<em><b>Save Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Save Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Save Time</em>' attribute.
	 * @see #setSaveTime(double)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_SaveTime()
	 * @model
	 * @generated
	 */
	double getSaveTime();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getSaveTime <em>Save Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Save Time</em>' attribute.
	 * @see #getSaveTime()
	 * @generated
	 */
	void setSaveTime(double value);

	/**
	 * Returns the value of the '<em><b>Total Execution Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Total Execution Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Total Execution Time</em>' attribute.
	 * @see #setTotalExecutionTime(double)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_TotalExecutionTime()
	 * @model
	 * @generated
	 */
	double getTotalExecutionTime();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getTotalExecutionTime <em>Total Execution Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Total Execution Time</em>' attribute.
	 * @see #getTotalExecutionTime()
	 * @generated
	 */
	void setTotalExecutionTime(double value);

	/**
	 * Returns the value of the '<em><b>Meta Model Variante</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Meta Model Variante</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Meta Model Variante</em>' attribute.
	 * @see #setMetaModelVariante(String)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_MetaModelVariante()
	 * @model
	 * @generated
	 */
	String getMetaModelVariante();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getMetaModelVariante <em>Meta Model Variante</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Meta Model Variante</em>' attribute.
	 * @see #getMetaModelVariante()
	 * @generated
	 */
	void setMetaModelVariante(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Max Used Memory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Used Memory</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Used Memory</em>' attribute.
	 * @see #setMaxUsedMemory(int)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getConfiguration_MaxUsedMemory()
	 * @model
	 * @generated
	 */
	int getMaxUsedMemory();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration#getMaxUsedMemory <em>Max Used Memory</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Used Memory</em>' attribute.
	 * @see #getMaxUsedMemory()
	 * @generated
	 */
	void setMaxUsedMemory(int value);

} // Configuration
