/*******************************************************************************
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabriel Barbier (Mia-Software)
 *******************************************************************************/
package org.eclipse.gmt.modisco.kdm.browser.extension.core;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmt.modisco.infra.browser.uicore.extensions.naming.AbstractNameProvider;
import org.eclipse.gmt.modisco.omg.kdm.core.AggregatedRelationship;
import org.eclipse.gmt.modisco.omg.kdm.core.Element;
import org.eclipse.gmt.modisco.omg.kdm.core.KDMEntity;
import org.eclipse.gmt.modisco.omg.kdm.core.KDMRelationship;
import org.eclipse.gmt.modisco.omg.kdm.core.ModelElement;

/**
 * @generated
 */
public class NameProvider extends AbstractNameProvider {
// Start of user code for additional methods and attributes
 	
// End of user code

//	Start of user code name attribute for KDMEntity		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getKDMEntityName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for KDMRelationship		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getKDMRelationshipName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for AggregatedRelationship		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getAggregatedRelationshipName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for ModelElement		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getModelElementName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for Element		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getElementName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code

	/**
	 * @generated
	 */
	public NameProvider() {
	}

	/**
	 * @return the name that must be displayed for the given {@link EObject}, or <code>null</code>
	 *         to keep the default name (or let another {@link NameProvider} provide the name)
	 * 
	 * @generated
	 */
	public String getName(EObject eObject) {
		String result = this.getDefaultName(eObject);
    	if (eObject instanceof KDMEntity) {
      		result = this.getKDMEntityName(eObject);
    	} else
    	if (eObject instanceof KDMRelationship) {
      		result = this.getKDMRelationshipName(eObject);
    	} else
    	if (eObject instanceof AggregatedRelationship) {
      		result = this.getAggregatedRelationshipName(eObject);
    	} else
    	if (eObject instanceof ModelElement) {
      		result = this.getModelElementName(eObject);
    	} else
    	if (eObject instanceof Element) {
      		result = this.getElementName(eObject);
    	} 
		return result;
	}

}

