/*******************************************************************************
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabriel Barbier (Mia-Software)
 *******************************************************************************/
package org.eclipse.gmt.modisco.kdm.browser.extension.platform;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmt.modisco.infra.browser.uicore.extensions.naming.AbstractNameProvider;
import org.eclipse.gmt.modisco.omg.kdm.platform.AbstractPlatformElement;
import org.eclipse.gmt.modisco.omg.kdm.platform.AbstractPlatformRelationship;
import org.eclipse.gmt.modisco.omg.kdm.platform.BindsTo;
import org.eclipse.gmt.modisco.omg.kdm.platform.DataManager;
import org.eclipse.gmt.modisco.omg.kdm.platform.DefinedBy;
import org.eclipse.gmt.modisco.omg.kdm.platform.DeployedComponent;
import org.eclipse.gmt.modisco.omg.kdm.platform.DeployedResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.DeployedSoftwareSystem;
import org.eclipse.gmt.modisco.omg.kdm.platform.ExecutionResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.ExternalActor;
import org.eclipse.gmt.modisco.omg.kdm.platform.FileResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.Loads;
import org.eclipse.gmt.modisco.omg.kdm.platform.LockResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.Machine;
import org.eclipse.gmt.modisco.omg.kdm.platform.ManagesResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.MarshalledResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.MessagingResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.NamingResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.PlatformAction;
import org.eclipse.gmt.modisco.omg.kdm.platform.PlatformElement;
import org.eclipse.gmt.modisco.omg.kdm.platform.PlatformEvent;
import org.eclipse.gmt.modisco.omg.kdm.platform.PlatformModel;
import org.eclipse.gmt.modisco.omg.kdm.platform.PlatformRelationship;
import org.eclipse.gmt.modisco.omg.kdm.platform.Process;
import org.eclipse.gmt.modisco.omg.kdm.platform.ReadsResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.Requires;
import org.eclipse.gmt.modisco.omg.kdm.platform.ResourceType;
import org.eclipse.gmt.modisco.omg.kdm.platform.RuntimeResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.Spawns;
import org.eclipse.gmt.modisco.omg.kdm.platform.StreamResource;
import org.eclipse.gmt.modisco.omg.kdm.platform.Thread;
import org.eclipse.gmt.modisco.omg.kdm.platform.WritesResource;

/**
 * @generated
 */
public class NameProvider extends AbstractNameProvider {
// Start of user code for additional methods and attributes
 	
// End of user code

//	Start of user code name attribute for Process		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getProcessName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for Thread		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getThreadName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for NamingResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getNamingResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for MarshalledResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getMarshalledResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for MessagingResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getMessagingResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for FileResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getFileResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for ExecutionResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getExecutionResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for LockResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getLockResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for StreamResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getStreamResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for DataManager		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getDataManagerName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for PlatformEvent		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getPlatformEventName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for ExternalActor		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getExternalActorName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for RuntimeResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getRuntimeResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for PlatformModel		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getPlatformModelName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for ResourceType		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getResourceTypeName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for PlatformAction		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getPlatformActionName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for BindsTo		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getBindsToName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for Requires		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getRequiresName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for ManagesResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getManagesResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for ReadsResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getReadsResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for WritesResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getWritesResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for DefinedBy		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getDefinedByName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for DeployedComponent		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getDeployedComponentName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for DeployedSoftwareSystem		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getDeployedSoftwareSystemName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for Machine		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getMachineName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for DeployedResource		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getDeployedResourceName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for Loads		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getLoadsName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for Spawns		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getSpawnsName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for PlatformElement		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getPlatformElementName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for PlatformRelationship		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getPlatformRelationshipName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for AbstractPlatformElement		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getAbstractPlatformElementName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code
//	Start of user code name attribute for AbstractPlatformRelationship		
	/**
	 * remove this annotation to indicate that code has been changed manually.
	 * @generated
	 */
	private final String getAbstractPlatformRelationshipName(EObject eObject) {
		String name = this.getDefaultName(eObject);
		return name;
	}
//	End of user code

	/**
	 * @generated
	 */
	public NameProvider() {
	}

	/**
	 * @return the name that must be displayed for the given {@link EObject}, or <code>null</code>
	 *         to keep the default name (or let another {@link NameProvider} provide the name)
	 * 
	 * @generated
	 */
	public String getName(EObject eObject) {
		String result = this.getDefaultName(eObject);
    	if (eObject instanceof Process) {
      		result = this.getProcessName(eObject);
    	} else
    	if (eObject instanceof Thread) {
      		result = this.getThreadName(eObject);
    	} else
    	if (eObject instanceof NamingResource) {
      		result = this.getNamingResourceName(eObject);
    	} else
    	if (eObject instanceof MarshalledResource) {
      		result = this.getMarshalledResourceName(eObject);
    	} else
    	if (eObject instanceof MessagingResource) {
      		result = this.getMessagingResourceName(eObject);
    	} else
    	if (eObject instanceof FileResource) {
      		result = this.getFileResourceName(eObject);
    	} else
    	if (eObject instanceof ExecutionResource) {
      		result = this.getExecutionResourceName(eObject);
    	} else
    	if (eObject instanceof LockResource) {
      		result = this.getLockResourceName(eObject);
    	} else
    	if (eObject instanceof StreamResource) {
      		result = this.getStreamResourceName(eObject);
    	} else
    	if (eObject instanceof DataManager) {
      		result = this.getDataManagerName(eObject);
    	} else
    	if (eObject instanceof PlatformEvent) {
      		result = this.getPlatformEventName(eObject);
    	} else
    	if (eObject instanceof ExternalActor) {
      		result = this.getExternalActorName(eObject);
    	} else
    	if (eObject instanceof RuntimeResource) {
      		result = this.getRuntimeResourceName(eObject);
    	} else
    	if (eObject instanceof PlatformModel) {
      		result = this.getPlatformModelName(eObject);
    	} else
    	if (eObject instanceof ResourceType) {
      		result = this.getResourceTypeName(eObject);
    	} else
    	if (eObject instanceof PlatformAction) {
      		result = this.getPlatformActionName(eObject);
    	} else
    	if (eObject instanceof BindsTo) {
      		result = this.getBindsToName(eObject);
    	} else
    	if (eObject instanceof Requires) {
      		result = this.getRequiresName(eObject);
    	} else
    	if (eObject instanceof ManagesResource) {
      		result = this.getManagesResourceName(eObject);
    	} else
    	if (eObject instanceof ReadsResource) {
      		result = this.getReadsResourceName(eObject);
    	} else
    	if (eObject instanceof WritesResource) {
      		result = this.getWritesResourceName(eObject);
    	} else
    	if (eObject instanceof DefinedBy) {
      		result = this.getDefinedByName(eObject);
    	} else
    	if (eObject instanceof DeployedComponent) {
      		result = this.getDeployedComponentName(eObject);
    	} else
    	if (eObject instanceof DeployedSoftwareSystem) {
      		result = this.getDeployedSoftwareSystemName(eObject);
    	} else
    	if (eObject instanceof Machine) {
      		result = this.getMachineName(eObject);
    	} else
    	if (eObject instanceof DeployedResource) {
      		result = this.getDeployedResourceName(eObject);
    	} else
    	if (eObject instanceof Loads) {
      		result = this.getLoadsName(eObject);
    	} else
    	if (eObject instanceof Spawns) {
      		result = this.getSpawnsName(eObject);
    	} else
    	if (eObject instanceof PlatformElement) {
      		result = this.getPlatformElementName(eObject);
    	} else
    	if (eObject instanceof PlatformRelationship) {
      		result = this.getPlatformRelationshipName(eObject);
    	} else
    	if (eObject instanceof AbstractPlatformElement) {
      		result = this.getAbstractPlatformElementName(eObject);
    	} else
    	if (eObject instanceof AbstractPlatformRelationship) {
      		result = this.getAbstractPlatformRelationshipName(eObject);
    	} 
		return result;
	}

}

